# coding: utf-8

"""
    Cashfree Payout APIs

    Cashfree's Payout APIs provide developers with a streamlined pathway to integrate advanced payout capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2024-01-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from cashfree_payout.models.create_transfer_response import CreateTransferResponse

class FetchBatchTransferResponse(BaseModel):
    """
    Batch Transfer Status V2 Response
    """
    batch_transfer_id: Optional[StrictStr] = Field(None, description="It displays the unique ID you created to identify the batch transfer.")
    cf_batch_transfer_id: Optional[StrictStr] = Field(None, description="It displays the unique ID created by Cashfree Payments. You receive this ID in the response after initiating the batch transfer request.")
    status: Optional[StrictStr] = Field(None, description="It displays the status of the batch transfer.")
    transfers: Optional[conlist(CreateTransferResponse)] = None
    __properties = ["batch_transfer_id", "cf_batch_transfer_id", "status", "transfers"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> FetchBatchTransferResponse:
        """Create an instance of FetchBatchTransferResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> FetchBatchTransferResponse:
        """Create an instance of FetchBatchTransferResponse from a JSON string"""
        temp_dict = json.loads(json_str)
        if "batch_transfer_id, cf_batch_transfer_id, status, transfers" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in transfers (list)
        _items = []
        if self.transfers:
            for _item in self.transfers:
                if _item:
                    _items.append(_item.to_dict())
            _dict['transfers'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> FetchBatchTransferResponse:
        """Create an instance of FetchBatchTransferResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return FetchBatchTransferResponse.parse_obj(obj)

        _obj = FetchBatchTransferResponse.parse_obj({
            "batch_transfer_id": obj.get("batch_transfer_id"),
            "cf_batch_transfer_id": obj.get("cf_batch_transfer_id"),
            "status": obj.get("status"),
            "transfers": [CreateTransferResponse.from_dict(_item) for _item in obj.get("transfers")] if obj.get("transfers") is not None else None
        })
        return _obj


